### Method

# Hitaki EfwProtocol transaction

#### Declaration [src]

    gboolean
    hitaki_efw_protocol_transaction (
      HitakiEfwProtocol* self,
      guint category,
      guint command,
      const guint32* args,
      gsize arg_count,
      guint32* const* params,
      gsize* param_count,
      guint timeout_ms,
      GError** error
    )

#### Description [src]

Transfer asynchronous transaction for request frame of Echo Efw protocol and wait for response matched to the command. The call results in `HitakiEfwProtocol::responded` signal with data of response.

#### Parameters

`category`

  Type: `guint`

  One of category for the transaction.

`command`

  Type: `guint`

  One of commands for the transaction.

`args`

  Type: An array of `guint32`

  An array with elements for quadlet data as arguments for command.

  The argument can be `NULL`.
  The length of the array is specified in the `arg_count` argument.
  The data is owned by the caller of the method.

`arg_count`

  Type: `gsize`

  The number of quadlets in the args array.

`params`

  Type: An array of `guint32*`

  An array with elements for quadlet data to save parameters in response. Callers should give it for buffer with enough space against the request since this library performs no reallocation. Due to the reason, the value of this argument should point to the pointer to the array and immutable. The content of array is mutable for parameters in response.

  The argument will be modified by the function.
  The argument can be set to `NULL` by the method.
  The length of the array is specified in the `param_count` argument.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.

`param_count`

  Type: `gsize*`

  The number of quadlets in the params array.

  The argument will be modified by the function.

`timeout_ms`

  Type: `guint`

  The timeout to wait for response.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

TRUE if the overall operation finished successfully, else FALSE.